﻿Imports System.Data
Imports System.Data.SqlClient
Imports System.Configuration
Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Dim query As String = "select distinct shipcountry from orders"
            Dim dt As DataTable = GetData(query)
            ddlCountry1.DataSource = dt
            ddlCountry1.DataTextField = "shipcountry"
            ddlCountry1.DataValueField = "shipcountry"
            ddlCountry1.DataBind()

            ddlCountry2.DataSource = dt
            ddlCountry2.DataTextField = "shipcountry"
            ddlCountry2.DataValueField = "shipcountry"
            ddlCountry2.DataBind()
            ddlCountry2.Items(1).Selected = True
        End If
    End Sub

    Protected Sub Compare(sender As Object, e As EventArgs)
        Dim query As String = String.Format("select datepart(year, orderdate) Year, count(datepart(year, orderdate)) TotalOrders  from orders where shipcountry = '{0}' group by datepart(year, orderdate)", ddlCountry1.SelectedItem.Value)
        Dim dt As DataTable = GetData(query)

        Dim x As String() = New String(dt.Rows.Count - 1) {}
        Dim y As Decimal() = New Decimal(dt.Rows.Count - 1) {}
        For i As Integer = 0 To dt.Rows.Count - 1
            x(i) = dt.Rows(i)(0).ToString()
            y(i) = Convert.ToInt32(dt.Rows(i)(1))
        Next
        LineChart1.Series.Add(New AjaxControlToolkit.LineChartSeries() With { _
         .Name = ddlCountry1.SelectedItem.Value, _
         .Data = y _
        })

        query = String.Format("select datepart(year, orderdate) Year, count(datepart(year, orderdate)) TotalOrders  from orders where shipcountry = '{0}' group by datepart(year, orderdate)", ddlCountry2.SelectedItem.Value)
        dt = GetData(query)

        y = New Decimal(dt.Rows.Count - 1) {}
        For i As Integer = 0 To dt.Rows.Count - 1
            x(i) = dt.Rows(i)(0).ToString()
            y(i) = Convert.ToInt32(dt.Rows(i)(1))
        Next
        LineChart1.Series.Add(New AjaxControlToolkit.LineChartSeries() With { _
         .Name = ddlCountry2.SelectedItem.Value, _
         .Data = y _
        })
        LineChart1.CategoriesAxis = String.Join(",", x)

        LineChart1.ChartTitle = String.Format("{0} and {1} Order Distribution", ddlCountry1.SelectedItem.Value, ddlCountry2.SelectedItem.Value)
        LineChart1.Visible = True
    End Sub

    Private Shared Function GetData(query As String) As DataTable
        Dim dt As New DataTable()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query)
                Using sda As New SqlDataAdapter()
                    cmd.CommandType = CommandType.Text
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    sda.Fill(dt)
                End Using
            End Using
            Return dt
        End Using
    End Function
End Class

